#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <fstream.h>
//______________________________________________________________________________________________________________________
//  Global declarations are defined below:
//______________________________________________________________________________________________________________________
ifstream input_file;
ofstream output_file;
int num_of_bitmaps, temp1;
double final_num;
char finalfile[30], file_pos, chk_chr;
//______________________________________________________________________________________________________________________
//  Function prototypes are defined below:
//______________________________________________________________________________________________________________________
void GET_image2D_number();
void GET_use_palette();
void GET_position_X();
void GET_position_Y();
void GET_bitmap_plane();
void GET_bitmap_plane_size();
void GET_bitmap_plane_memory_address();

void GET_address_multiplier();
//______________________________________________________________________________________________________________________
//  The Main Program is below:
//______________________________________________________________________________________________________________________
int main()
{
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"   Elbesem Engine :  BITMAP2D Tool - v1.0"<<endl;
 cout<<endl;
 cout<<"   - E2 data type :  BITMAP2D."<<endl;
 cout<<"   - Coded by     :  Zaksund."<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<endl;
 cout<<"[String between 1 and 30 characters in length (include extension, ex:  '.txt')]"<<endl;
 cout<<">> E2 output file name :  "; cin>>finalfile;
 output_file.open("zdump");
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 GET_image2D_number(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
 GET_use_palette(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
 GET_position_X(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
 GET_position_Y(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
 GET_bitmap_plane(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
 GET_bitmap_plane_size(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
 GET_bitmap_plane_memory_address(); final_num *= .0000001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;
 GET_address_multiplier(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;

 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 file_pos = '.';
 cout<<endl;
 cout<<".. removing periods (please wait) ..";
 output_file.close(); input_file.open("zdump"); output_file.open(finalfile);
 while(!input_file.eof())
 {
  if(file_pos != '.')
   output_file<<file_pos;
  input_file>>file_pos;
 }
 input_file.close(); output_file.close();
 cout<<endl; cout<<endl;
 cout<<".. FILE CREATION COMPLETED SUCCESSFULLY!!"<<endl;
 cout<<".. '"<<finalfile<<"'"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 system("PAUSE"); return 0;
}
//______________________________________________________________________________________________________________________
//  Functions are defined below:
//______________________________________________________________________________________________________________________
void GET_image2D_number()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> BITMAP2D["<<temp1<<"].image2D_pal_number            :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_image2D_number();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_image2D_number();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_use_palette()
{
 cout<<endl;
 cout<<"[Integer between 0 and 7]"<<endl;
 cout<<">> BITMAP2D["<<temp1<<"].use_palette                   :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_use_palette();
 }
 if(final_num > 7)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 7."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_use_palette();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_position_X()
{
 cout<<endl;
 cout<<"[Integer between -9999 and 9999]"<<endl;
 cout<<">> BITMAP2D["<<temp1<<"].position[X]                   :  "; cin>>final_num;
 if(final_num < -9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -10000;
  GET_position_X();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -10000;
  GET_position_X();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_position_Y()
{
 cout<<endl;
 cout<<"[Integer between -9999 and 9999]"<<endl;
 cout<<">> BITMAP2D["<<temp1<<"].position[Y]                   :  "; cin>>final_num;
 if(final_num < -9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -10000;
  GET_position_Y();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -10000;
  GET_position_Y();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_bitmap_plane()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (a/b) for NBG0 or NBG1]"<<endl;
 cout<<">> BITMAP2D["<<temp1<<"].use_NBG_plane                 :  "; cin>>chk_chr;
 if(chk_chr != 'A' && chk_chr != 'a' && chk_chr != 'B' && chk_chr != 'b')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (a/b) for NBG0 or NBG1."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  chk_chr = '|';
  GET_bitmap_plane();
 }
 if(chk_chr == 'A' || chk_chr == 'a')  final_num = 0;
 if(chk_chr == 'B' || chk_chr == 'b')  final_num = 1;
 return;
}
//______________________________________________________________________________________________________________________
void GET_bitmap_plane_size()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (a/b/c/d) for 512x256, 512x512, 1024x256, or 1024x512]"<<endl;
 cout<<">> BITMAP2D["<<temp1<<"].bitmap_plane_size             :  "; cin>>chk_chr;
 if(chk_chr != 'A' && chk_chr != 'a' && chk_chr != 'B' && chk_chr != 'b' && chk_chr != 'C' && chk_chr != 'c' && chk_chr != 'D' && chk_chr != 'd')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (a/b/c/d) for 512x256, 512x512, 1024x256, or "<<endl;
  cout<<"[!!ERROR!!]:  1024x512."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  chk_chr = '|';
  GET_bitmap_plane_size();
 }
 if(chk_chr == 'A' || chk_chr == 'a')  final_num = 0;
 if(chk_chr == 'B' || chk_chr == 'b')  final_num = 1;
 if(chk_chr == 'C' || chk_chr == 'c')  final_num = 2;
 if(chk_chr == 'D' || chk_chr == 'd')  final_num = 3;
 return;
}
//______________________________________________________________________________________________________________________
void GET_bitmap_plane_memory_address()
{
 cout<<endl;
 cout<<"[Integer between 0 and 99999999]"<<endl;
 cout<<">> BITMAP2D["<<temp1<<"].bitmap_memory_storage_address :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_bitmap_plane_memory_address();
 }
 if(final_num > 99999999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 99999999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_bitmap_plane_memory_address();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_address_multiplier()
{
 cout<<endl;
 cout<<"[Integer between 1 and 9999]"<<endl;
 cout<<">> ["<<temp1<<"] memory address multiplier             :  "; cin>>final_num;
 if(final_num < 1)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 1."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_address_multiplier();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_address_multiplier();
 }
 return;
}
//______________________________________________________________________________________________________________________
// END OF PROGRAM!!
//______________________________________________________________________________________________________________________
