#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <fstream.h>
//______________________________________________________________________________________________________________________
//  Global declarations are defined below:
//______________________________________________________________________________________________________________________
ifstream input_file;
ofstream output_file;
int num_of_cels;
int cel_sizes[100];
int num_1, num_2, num_3, num_4, total_nums;
int total_cel_sizes = 0;
int temp1, temp2, temp3, temp4, temp5;
char openfile[100][30], finalfile[30], file_pos, chk_chr;
double final_num;
//______________________________________________________________________________________________________________________
//  Function prototypes are defined below:
//______________________________________________________________________________________________________________________
void GET_num_of_cels();
void GET_cel_size();
int  asc_chk(char num);
//______________________________________________________________________________________________________________________
//  The Main Program is below:
//______________________________________________________________________________________________________________________
int main()
{
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"   Elbesem Engine :  CEL2D Tool - v1.0"<<endl;
 cout<<endl;
 cout<<"   - E2 data type :  CEL2D."<<endl;
 cout<<"   - Coded by     :  Zaksund."<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<endl;
 cout<<"!! Please make sure you've already:"<<endl;
 cout<<"   *  Converted the 2D images using 'Map Editor.exe'."<<endl;
 cout<<"   *  Saved your files as '.map/cel/pal' files."<<endl;
 cout<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<endl;
 cout<<"[String between 1 and 30 characters in length (include extension, ex:  '.txt')]"<<endl;
 cout<<">> E2 output file name :  "; cin>>finalfile;
 cout<<endl;
 GET_num_of_cels(); output_file.open("zdump"); final_num = num_of_cels *.001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;

 for(temp1 = 0; temp1 != num_of_cels; temp1++)
 {
  cout<<"| CEL2D # ("<<temp1<<" / "<<num_of_cels - 1<<") |"<<endl;
  cout<<endl;
  cout<<"[String between 1 and 30 characters in length (include '.cel' extension)]"<<endl;
  cout<<">> CEL2D '.cel' file name :  "; cin>>openfile[temp1]; input_file.open(openfile[temp1]);
  GET_cel_size();
  cout<<endl;
  cout<<".. CEL2D #["<<temp1<<"] Total Size = "<<cel_sizes[temp1] * 256<<"!!"<<endl;
  cout<<"______________________________________________________________________________"<<endl;
  final_num = cel_sizes[temp1] * .001; output_file.setf(/*ios::showpos|*/ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  input_file.close();
 }
 cout<<"______________________________________________________________________________"<<endl;
 cout<<".. now converting   (please wait) .."<<endl;

 for(temp1 = 0; temp1 != num_of_cels; temp1++)
 {
  input_file.open(openfile[temp1]);
  if(input_file == 0x0)
  {
   cout<<endl;
   cout<<"------------------------------------------------------------------------------"<<endl;
   cout<<"[!!ERROR!!]:  The file:  '"<<openfile[temp1]<<"' couldn't be found."<<endl;
   cout<<"[!!ERROR!!]:  Please check the file name and location, and try again."<<endl;
   cout<<"------------------------------------------------------------------------------"<<endl;
   cout<<endl;
   cout<<".. FILE CREATION FAILED!!"<<endl;
   cout<<".. '"<<finalfile<<"'"<<endl;
   cout<<"______________________________________________________________________________"<<endl;
   cout<<"______________________________________________________________________________"<<endl;
   system("PAUSE");
   return(0);
  }

  while(file_pos != '{')
  {
   input_file>>file_pos;
  }
  for(temp2 = 0; temp2 != cel_sizes[temp1] * 32; temp2++)
  {
   for(temp3 = 0; temp3 != 8; temp3++)
   {
    while(file_pos != 'x')
    {
     input_file>>file_pos;
    }
    input_file>>file_pos; num_1 = (int)file_pos; temp4 = asc_chk(num_1); num_1 = temp4; num_1 = (num_1 * 16);
    input_file>>file_pos; num_2 = (int)file_pos; temp4 = asc_chk(num_2); num_2 = temp4; num_2 = (num_2);
    total_nums = num_1 + num_2; final_num = total_nums * .01; output_file.setf(/*ios::showpos|*/ios::fixed|ios::showpoint);output_file<<setw(3)<<setprecision(2)<<final_num; file_pos = '.';
   }
  }
  input_file.close();
 }

 cout<<endl;
 cout<<".. removing periods (please wait) ..";
 output_file.close(); input_file.open("zdump"); output_file.open(finalfile);

 while(!input_file.eof())
 {
  if(file_pos != '.')
   output_file<<file_pos;
  input_file>>file_pos;
 }
 input_file.close(); output_file.close();
 cout<<endl; cout<<endl;
 cout<<".. FILE CREATION COMPLETED SUCCESSFULLY!!"<<endl;
 cout<<".. '"<<finalfile<<"'"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 system("PAUSE"); return 0;
}
//______________________________________________________________________________________________________________________
//  Functions are defined below:
//______________________________________________________________________________________________________________________
void GET_num_of_cels()
{
 cout<<endl;
 cout<<"[Integer between 1 and 9999]"<<endl;
 cout<<">> Number of CEL2Ds       :  "; cin>>num_of_cels;
 if(num_of_cels < 1)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 1."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  num_of_cels = 0;
  GET_num_of_cels();
 }
 if(num_of_cels > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  num_of_cels = 0;
  GET_num_of_cels();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_cel_size()
{
 cout<<endl;
 cout<<"[Integer between 1 and 9999]"<<endl;
 cout<<">> Number of characters   :  "; cin>>cel_sizes[temp1];;
 if(cel_sizes[temp1] < 1)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 1."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  cel_sizes[temp1] = 0;
  GET_cel_size();
 }
 if(cel_sizes[temp1] > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  cel_sizes[temp1] = 0;
  GET_cel_size();
 }
 return;
}
//______________________________________________________________________________________________________________________
int asc_chk(char num)
{
 int temp1;
 temp1 = (int)num;
 switch(temp1)
 {
  case 48:
   temp1 = 0;
   break;
  case 49:
   temp1 = 1;
   break;
  case 50:
   temp1 = 2;
   break;
  case 51:
   temp1 = 3;
   break;
  case 52:
   temp1 = 4;
   break;
  case 53:
   temp1 = 5;
   break;
  case 54:
   temp1 = 6;
   break;
  case 55:
   temp1 = 7;
   break;
  case 56:
   temp1 = 8;
   break;
  case 57:
   temp1 = 9;
   break;
  case 97:
   temp1 = 10;
   break;
  case 98:
   temp1 = 11;
   break;
  case 99:
   temp1 = 12;
   break;
  case 100:
   temp1 = 13;
   break;
  case 101:
   temp1 = 14;
   break;
  case 102:
   temp1 = 15;
   break;
 }
 return(temp1);
}
//______________________________________________________________________________________________________________________
// END OF PROGRAM!!
//______________________________________________________________________________________________________________________
