#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <fstream.h>
//______________________________________________________________________________________________________________________
//  Global declarations are defined below:
//______________________________________________________________________________________________________________________
ifstream input_file;
ofstream output_file;
int num_of_collision_boxes, temp1, temp2;
double final_num;
char finalfile[30], file_pos, chk_chr;
//______________________________________________________________________________________________________________________
//  Function prototypes are defined below:
//______________________________________________________________________________________________________________________
void GET_num_of_collision_boxes();
void GET_box_data();
//______________________________________________________________________________________________________________________
//  The Main Program is below:
//______________________________________________________________________________________________________________________
int main()
{
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"   Elbesem Engine :  COLLISION_BOX Tool - v1.0"<<endl;
 cout<<endl;
 cout<<"   - E2 data type :  COLLISION_BOX."<<endl;
 cout<<"   - Coded by     :  Zaksund."<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<endl;
 cout<<"[String between 1 and 30 characters in length (include extension, ex:  '.txt')]"<<endl;
 cout<<">> E2 output file name :  "; cin>>finalfile;
 output_file.open("zdump");
 GET_num_of_collision_boxes(); final_num = num_of_collision_boxes *.001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 for(temp1 = 0; temp1 != num_of_collision_boxes; temp1++)
 {
  cout<<"| COLLISION_BOX # ("<<temp1<<" / "<<num_of_collision_boxes - 1<<") |"<<endl;
  output_file.unsetf(ios::showpos);
  for(temp2 = 0; temp2 != 6; temp2++)
  {
   GET_box_data(); final_num *= .001;
   output_file.setf(ios::showpos|ios::fixed|ios::showpoint);
   output_file<<setw(8)<<setprecision(7)<<final_num;
  }
  cout<<"______________________________________________________________________________"<<endl;
 }
 cout<<"______________________________________________________________________________"<<endl;
 file_pos = '.';
 cout<<endl;
 cout<<".. removing periods (please wait) ..";
 output_file.close(); input_file.open("zdump"); output_file.open(finalfile);
 while(!input_file.eof())
 {
  if(file_pos != '.')
   output_file<<file_pos;
  input_file>>file_pos;
 }
 input_file.close(); output_file.close();
 cout<<endl; cout<<endl;
 cout<<".. FILE CREATION COMPLETED SUCCESSFULLY!!"<<endl;
 cout<<".. '"<<finalfile<<"'"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 system("PAUSE"); return 0;
}
//______________________________________________________________________________________________________________________
//  Functions are defined below:
//______________________________________________________________________________________________________________________
void GET_num_of_collision_boxes()
{
 cout<<endl;
 cout<<"[Integer between 1 and 9999]"<<endl;
 cout<<">> Number of COLLISION_BOXs                   :  "; cin>>num_of_collision_boxes;
 if(num_of_collision_boxes < 1)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 1."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  num_of_collision_boxes = 0;
  GET_num_of_collision_boxes();
 }
 if(num_of_collision_boxes > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  num_of_collision_boxes = 0;
  GET_num_of_collision_boxes();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_box_data()
{
 cout<<endl;
 cout<<"[FIXED between -9999.9999 and 9999.9999]"<<endl;
 switch(temp2)
 {
  case 0:
   cout<<">> COLLISION_BOX["<<temp1<<"].collision_left_boundary   :  "; cin>>final_num;
   break;

  case 1:
   cout<<">> COLLISION_BOX["<<temp1<<"].collision_right_boundary  :  "; cin>>final_num;
   break;

  case 2:
   cout<<">> COLLISION_BOX["<<temp1<<"].collision_top_boundary    :  "; cin>>final_num;
   break;

  case 3:
   cout<<">> COLLISION_BOX["<<temp1<<"].collision_bottom_boundary :  "; cin>>final_num;
   break;

  case 4:
   cout<<">> COLLISION_BOX["<<temp1<<"].collision_front_boundary  :  "; cin>>final_num;
   break;

  case 5:
   cout<<">> COLLISION_BOX["<<temp1<<"].collision_back_boundary   :  "; cin>>final_num;
   break;
 }
 if(final_num < -9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_box_data();
 }
 if(final_num > 9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_box_data();
 }
 return;
}
//______________________________________________________________________________________________________________________
// END OF PROGRAM!!
//______________________________________________________________________________________________________________________
