#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <fstream.h>
//______________________________________________________________________________________________________________________
//  Global declarations are defined below:
//______________________________________________________________________________________________________________________
ifstream input_file;
ofstream output_file;
int num_of_maps;
int map_sizes[100][5];
int num_1, num_2, num_3, num_4, total_nums;
int total_map_sizes = 0;
int temp1, temp2, temp3, temp4, temp5;
char openfile[100][30], finalfile[30], file_pos, chk_chr;
double final_num;
//______________________________________________________________________________________________________________________
//  Function prototypes are defined below:
//______________________________________________________________________________________________________________________
void GET_num_of_maps();
void GET_map_size();
int  asc_chk(char num);
//______________________________________________________________________________________________________________________
//  The Main Program is below:
//______________________________________________________________________________________________________________________
int main()
{
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"   Elbesem Engine :  MAP2D Tool - v1.0"<<endl;
 cout<<endl;
 cout<<"   - E2 data type :  MAP2D."<<endl;
 cout<<"   - Coded by     :  Zaksund."<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<endl;
 cout<<"!! Please make sure you've already:"<<endl;
 cout<<"   *  Converted the 2D images using 'Map Editor.exe'."<<endl;
 cout<<"   *  Saved your files as '.map/cel/pal' files."<<endl;
 cout<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<endl;
 cout<<"[String between 1 and 30 characters in length (include extension, ex:  '.txt')]"<<endl;
 cout<<">> E2 output file name :  "; cin>>finalfile;
 cout<<endl;
 GET_num_of_maps(); output_file.open("zdump"); final_num = num_of_maps *.001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;

 for(temp1 = 0; temp1 != num_of_maps; temp1++)
 {
  cout<<"| MAP2D # ("<<temp1<<" / "<<num_of_maps - 1<<") |"<<endl;
  cout<<endl;
  cout<<"[String between 1 and 30 characters in length (include '.map' extension)]"<<endl;
  cout<<">> MAP2D '.map' file name :  "; cin>>openfile[temp1]; input_file.open(openfile[temp1]);
  GET_map_size();
  map_sizes[temp1][4] = (((map_sizes[temp1][0] * map_sizes[temp1][1]) * (map_sizes[temp1][2] * map_sizes[temp1][3])) * 1024) / 8;
  cout<<endl;
  cout<<".. MAP2D #["<<temp1<<"] Total Size = "<<map_sizes[temp1][4] * 8<<"!!"<<endl;
  cout<<"______________________________________________________________________________"<<endl;
  final_num = map_sizes[temp1][4] * .001; output_file.setf(/*ios::showpos|*/ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  input_file.close();
 }
 cout<<"______________________________________________________________________________"<<endl;
 cout<<".. now converting   (please wait) .."<<endl;

 for(temp1 = 0; temp1 != num_of_maps; temp1++)
 {
  input_file.open(openfile[temp1]);
  if(input_file == 0x0)
  {
   cout<<endl;
   cout<<"------------------------------------------------------------------------------"<<endl;
   cout<<"[!!ERROR!!]:  The file:  '"<<openfile[temp1]<<"' couldn't be found."<<endl;
   cout<<"[!!ERROR!!]:  Please check the file name and location, and try again."<<endl;
   cout<<"------------------------------------------------------------------------------"<<endl;
   cout<<endl;
   cout<<".. FILE CREATION FAILED!!"<<endl;
   cout<<".. '"<<finalfile<<"'"<<endl;
   cout<<"______________________________________________________________________________"<<endl;
   cout<<"______________________________________________________________________________"<<endl;
   system("PAUSE");
   return(0);
  }
  while(file_pos != '{')
  {
   input_file>>file_pos;
  }
  for(temp2 = 0; temp2 != map_sizes[temp1][4]; temp2++)
  {
   for(temp3 = 0; temp3 != 8; temp3++)
   {
    while(file_pos != 'x')
    {
     input_file>>file_pos;
    }
    input_file>>file_pos; num_1 = (int)file_pos; temp4 = asc_chk(num_1); num_1 = temp4; num_1 = (num_1 * 16 * 16 * 16);
    input_file>>file_pos; num_2 = (int)file_pos; temp4 = asc_chk(num_2); num_2 = temp4; num_2 = (num_2 * 16 * 16);
    input_file>>file_pos; num_3 = (int)file_pos; temp4 = asc_chk(num_3); num_3 = temp4; num_3 = (num_3 * 16);
    input_file>>file_pos; num_4 = (int)file_pos; temp4 = asc_chk(num_4); num_4 = temp4; num_4 = (num_4);
    total_nums = num_1 + num_2 + num_3 + num_4; final_num = total_nums * .001; output_file.setf(/*ios::showpos|*/ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num; file_pos = '.';
   }
  }
  input_file.close();
 }

 cout<<endl;
 cout<<".. removing periods (please wait) ..";
 output_file.close(); input_file.open("zdump"); output_file.open(finalfile);

 while(!input_file.eof())
 {
  if(file_pos != '.')
   output_file<<file_pos;
  input_file>>file_pos;
 }
 cout<<endl; cout<<endl;
 cout<<".. FILE CREATION COMPLETED SUCCESSFULLY!!"<<endl;
 cout<<".. '"<<finalfile<<"'"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 system("PAUSE"); return 0;
}
//______________________________________________________________________________________________________________________
//  Functions are defined below:
//______________________________________________________________________________________________________________________
void GET_num_of_maps()
{
 cout<<endl;
 cout<<"[Integer between 1 and 9999]"<<endl;
 cout<<">> Number of MAP2Ds       :  "; cin>>num_of_maps;
 if(num_of_maps < 1)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 1."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  num_of_maps = 0;
  GET_num_of_maps();
 }
 if(num_of_maps > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  num_of_maps = 0;
  GET_num_of_maps();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_map_size()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (a/b/c) for a 1x1, 2x1, or 2x2 map size]"<<endl;
 cout<<">> MAP2D["<<temp1<<"].map_size      :  "; cin>>chk_chr;
 if(chk_chr != 'A' && chk_chr != 'a' && chk_chr != 'B' && chk_chr != 'b' && chk_chr != 'C' && chk_chr != 'c')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (a/b/c) for a 1x1, 2x1, or 2x2 map size."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  chk_chr = '|';
  GET_map_size();
 }

 map_sizes[temp1][0] = 1; map_sizes[temp1][1] = 1;     // Sorry, only one map is supported :P...max of 2x2 planes
 if(chk_chr == 'A' || chk_chr == 'a'){ map_sizes[temp1][2] = 1; map_sizes[temp1][3] = 1;}
 if(chk_chr == 'B' || chk_chr == 'b'){ map_sizes[temp1][2] = 2; map_sizes[temp1][3] = 1;}
 if(chk_chr == 'C' || chk_chr == 'c'){ map_sizes[temp1][2] = 2; map_sizes[temp1][3] = 2;}
 return;
}
//______________________________________________________________________________________________________________________
int asc_chk(char num)
{
 int temp1;
 temp1 = (int)num;
 switch(temp1)
 {
  case 48:
   temp1 = 0;
   break;
  case 49:
   temp1 = 1;
   break;
  case 50:
   temp1 = 2;
   break;
  case 51:
   temp1 = 3;
   break;
  case 52:
   temp1 = 4;
   break;
  case 53:
   temp1 = 5;
   break;
  case 54:
   temp1 = 6;
   break;
  case 55:
   temp1 = 7;
   break;
  case 56:
   temp1 = 8;
   break;
  case 57:
   temp1 = 9;
   break;
  case 97:
   temp1 = 10;
   break;
  case 98:
   temp1 = 11;
   break;
  case 99:
   temp1 = 12;
   break;
  case 100:
   temp1 = 13;
   break;
  case 101:
   temp1 = 14;
   break;
  case 102:
   temp1 = 15;
   break;
 }
 return(temp1);
}
//______________________________________________________________________________________________________________________
// END OF PROGRAM!!
//______________________________________________________________________________________________________________________
