#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <fstream.h>
//______________________________________________________________________________________________________________________
//  Global declarations are defined below:
//______________________________________________________________________________________________________________________
ifstream input_file;
ofstream output_file;
int num_of_sprites, temp1;
double final_num;
char finalfile[30], file_pos, chk_chr;
//______________________________________________________________________________________________________________________
//  Function prototypes are defined below:
//______________________________________________________________________________________________________________________
void GET_num_of_sprites();
void GET_scrollplane();

void GET_map_animate();
void GET_map_loop();
void GET_map_current_animation();
void GET_map_current_frame();
void GET_map_timer();

void GET_cel_animate();
void GET_cel_loop();
void GET_cel_current_animation();
void GET_cel_current_frame();
void GET_cel_timer();

void GET_palette_animate();
void GET_palette_loop();
void GET_palette_current_animation();
void GET_palette_current_frame();
void GET_palette_timer();

void GET_movement_animate();
void GET_movement_loop();
void GET_movement_current_animation();
void GET_movement_current_frame();
void GET_movement_timer_X();
void GET_movement_timer_Y();
/*
void GET_movement_timer_Z();

void GET_rotation_animate();
void GET_rotation_loop();
void GET_rotation_current_animation();
void GET_rotation_current_frame();
void GET_rotation_timer_X();
void GET_rotation_timer_Y();
void GET_rotation_timer_Z();
*/

void GET_scaling_animate();
void GET_scaling_loop();
void GET_scaling_current_animation();
void GET_scaling_current_frame();
void GET_scaling_timer_X();
void GET_scaling_timer_Y();

void GET_position_X();
void GET_position_Y();
/*
void GET_position_Z();

void GET_angle_X();
void GET_angle_Y();
void GET_angle_Z();
*/

void GET_scale_X();
void GET_scale_Y();

void GET_current_scrollplane_map();
void GET_current_scrollplane_cel();
void GET_current_scrollplane_palette();

void GET_scrollplane_map_memory_address();
void GET_scrollplane_cel_memory_address();
void GET_scrollplane_palette_memory_address();
void GET_address_multiplier();

void GET_use_palette();
//______________________________________________________________________________________________________________________
//  The Main Program is below:
//______________________________________________________________________________________________________________________
int main()
{
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"   Elbesem Engine :  SCROLLPLANE_BASIC Tool - v1.0"<<endl;
 cout<<endl;
 cout<<"   - E2 data type :  SCROLLPLANE_BASIC."<<endl;
 cout<<"   - Coded by     :  Zaksund."<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<endl;
 cout<<"[String between 1 and 30 characters in length (include extension, ex:  '.txt')]"<<endl;
 cout<<">> E2 output file name :  "; cin>>finalfile;
 output_file.open("zdump");
 GET_num_of_sprites(); final_num = num_of_sprites *.001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 for(temp1 = 0; temp1 != num_of_sprites; temp1++)
 {
  cout<<"| SCROLLPLANE_BASIC # ("<<temp1<<" / "<<num_of_sprites - 1<<") |"<<endl;
  output_file.unsetf(ios::showpos);
  GET_scrollplane(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;

  GET_map_animate(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  GET_map_loop(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  GET_map_current_animation(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_map_current_frame(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_map_timer(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;

  GET_cel_animate(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  GET_cel_loop(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  GET_cel_current_animation(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_cel_current_frame(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_cel_timer(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;

  GET_palette_animate(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  GET_palette_loop(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  GET_palette_current_animation(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_palette_current_frame(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_palette_timer(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;

  GET_movement_animate(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  GET_movement_loop(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  GET_movement_current_animation(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_movement_current_frame(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_movement_timer_X(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_movement_timer_Y(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
/*
  GET_movement_timer_Z(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;

  GET_rotation_animate(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  GET_rotation_loop(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  GET_rotation_current_animation(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_rotation_current_frame(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_rotation_timer_X(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_rotation_timer_Y(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_rotation_timer_Z(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
*/
  GET_scaling_animate(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  GET_scaling_loop(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  GET_scaling_current_animation(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_scaling_current_frame(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_scaling_timer_X(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_scaling_timer_Y(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;

  GET_position_X(); final_num *= .001; output_file.setf(ios::showpos|ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;
  GET_position_Y(); final_num *= .001; output_file.setf(ios::showpos|ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;
/*
  GET_position_Z(); final_num *= .001; output_file.setf(ios::showpos|ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;

  GET_angle_X(); final_num *= .001; output_file.setf(ios::showpos|ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;
  GET_angle_Y(); final_num *= .001; output_file.setf(ios::showpos|ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;
  GET_angle_Z(); final_num *= .001; output_file.setf(ios::showpos|ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;
*/
  GET_scale_X(); final_num *= .001; output_file.setf(ios::showpos|ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;
  GET_scale_Y(); final_num *= .001; output_file.setf(ios::showpos|ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;

  GET_current_scrollplane_map(); final_num *= .001; output_file.setf(ios::showpos|ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;
  GET_current_scrollplane_cel(); final_num *= .001; output_file.setf(ios::showpos|ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;
  GET_current_scrollplane_palette(); final_num *= .001; output_file.setf(ios::showpos|ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;

  output_file.unsetf(ios::showpos);
  GET_scrollplane_map_memory_address(); final_num *= .0000001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;
  GET_address_multiplier(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_scrollplane_cel_memory_address(); final_num *= .0000001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;
  GET_address_multiplier(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_scrollplane_palette_memory_address(); final_num *= .0000001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;
  GET_address_multiplier(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;

  GET_use_palette(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  output_file.unsetf(ios::showpos);
  cout<<"______________________________________________________________________________"<<endl;
 }
 cout<<"______________________________________________________________________________"<<endl;
 file_pos = '.';
 cout<<endl;
 cout<<".. removing periods (please wait) ..";
 output_file.close(); input_file.open("zdump"); output_file.open(finalfile);
 while(!input_file.eof())
 {
  if(file_pos != '.')
   output_file<<file_pos;
  input_file>>file_pos;
 }
 input_file.close(); output_file.close();
 cout<<endl; cout<<endl;
 cout<<".. FILE CREATION COMPLETED SUCCESSFULLY!!"<<endl;
 cout<<".. '"<<finalfile<<"'"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 system("PAUSE"); return 0;
}
//______________________________________________________________________________________________________________________
//  Functions are defined below:
//______________________________________________________________________________________________________________________
void GET_num_of_sprites()
{
 cout<<endl;
 cout<<"[Integer between 1 and 9999]"<<endl;
 cout<<">> Number of SCROLLPLANE_BASICs                            :  "; cin>>num_of_sprites;
 if(num_of_sprites < 1)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 1."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  num_of_sprites = 0;
  GET_num_of_sprites();
 }
 if(num_of_sprites > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  num_of_sprites = 0;
  GET_num_of_sprites();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_scrollplane()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (a/b/c/d/e) for plane NBG0, NBG1, NBG2, NBG3, or RBG0]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].use_scrollplane                    :  "; cin>>chk_chr;
 if(chk_chr != 'A' && chk_chr != 'a' && chk_chr != 'B' && chk_chr != 'b' && chk_chr != 'C' && chk_chr != 'c' && chk_chr != 'D' && chk_chr != 'd' && chk_chr != 'E' && chk_chr != 'e')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (a/b/c/d/e) for a NBG0, NBG1, NBG2, NBG3 or "<<endl;
  cout<<"[!!ERROR!!]:  RBG0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  chk_chr = '|';
  GET_scrollplane();
 }
 if(chk_chr == 'A' || chk_chr == 'a')  final_num = 0;
 if(chk_chr == 'B' || chk_chr == 'b')  final_num = 1;
 if(chk_chr == 'C' || chk_chr == 'c')  final_num = 2;
 if(chk_chr == 'D' || chk_chr == 'd')  final_num = 3;
 if(chk_chr == 'E' || chk_chr == 'e')  final_num = 4;
 return;
}
//______________________________________________________________________________________________________________________
void GET_map_animate()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (y/n) for YES or NO]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].map_animate                        :  "; cin>>chk_chr;
 if(chk_chr != 'Y' && chk_chr != 'y' && chk_chr != 'N' && chk_chr != 'n')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (y/n) for YES or NO."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  GET_map_animate();
 }
 if(chk_chr == 'Y' || chk_chr == 'y')  final_num = 1;
 if(chk_chr == 'N' || chk_chr == 'n')  final_num = 0;
 return;
}
//______________________________________________________________________________________________________________________
void GET_map_loop()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (y/n) for YES or NO]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].map_loop                           :  "; cin>>chk_chr;
 if(chk_chr != 'Y' && chk_chr != 'y' && chk_chr != 'N' && chk_chr != 'n')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (y/n) for YES or NO."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  GET_map_loop();
 }
 if(chk_chr == 'Y' || chk_chr == 'y')  final_num = 1;
 if(chk_chr == 'N' || chk_chr == 'n')  final_num = 0;
 return;
}
//______________________________________________________________________________________________________________________
void GET_map_current_animation()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].map_current_animation              :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_map_current_animation();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_map_current_animation();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_map_current_frame()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].map_current_frame                  :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_map_current_frame();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_map_current_frame();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_map_timer()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].map_timer                          :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_map_timer();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_map_timer();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_cel_animate()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (y/n) for YES or NO]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].cel_animate                        :  "; cin>>chk_chr;
 if(chk_chr != 'Y' && chk_chr != 'y' && chk_chr != 'N' && chk_chr != 'n')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (y/n) for YES or NO."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  GET_cel_animate();
 }
 if(chk_chr == 'Y' || chk_chr == 'y')  final_num = 1;
 if(chk_chr == 'N' || chk_chr == 'n')  final_num = 0;
 return;
}
//______________________________________________________________________________________________________________________
void GET_cel_loop()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (y/n) for YES or NO]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].cel_loop                           :  "; cin>>chk_chr;
 if(chk_chr != 'Y' && chk_chr != 'y' && chk_chr != 'N' && chk_chr != 'n')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (y/n) for YES or NO."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  GET_cel_loop();
 }
 if(chk_chr == 'Y' || chk_chr == 'y')  final_num = 1;
 if(chk_chr == 'N' || chk_chr == 'n')  final_num = 0;
 return;
}
//______________________________________________________________________________________________________________________
void GET_cel_current_animation()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].cel_current_animation              :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_cel_current_animation();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_cel_current_animation();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_cel_current_frame()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].cel_current_frame                  :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_cel_current_frame();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_cel_current_frame();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_cel_timer()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].cel_timer                          :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_cel_timer();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_cel_timer();
 }
 return;
}

//______________________________________________________________________________________________________________________
void GET_palette_animate()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (y/n) for YES or NO]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].palette_animate                    :  "; cin>>chk_chr;
 if(chk_chr != 'Y' && chk_chr != 'y' && chk_chr != 'N' && chk_chr != 'n')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (y/n) for YES or NO."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  GET_palette_animate();
 }
 if(chk_chr == 'Y' || chk_chr == 'y')  final_num = 1;
 if(chk_chr == 'N' || chk_chr == 'n')  final_num = 0;
 return;
}
//______________________________________________________________________________________________________________________
void GET_palette_loop()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (y/n) for YES or NO]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].palette_loop                       :  "; cin>>chk_chr;
 if(chk_chr != 'Y' && chk_chr != 'y' && chk_chr != 'N' && chk_chr != 'n')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (y/n) for YES or NO."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  GET_palette_loop();
 }
 if(chk_chr == 'Y' || chk_chr == 'y')  final_num = 1;
 if(chk_chr == 'N' || chk_chr == 'n')  final_num = 0;
 return;
}
//______________________________________________________________________________________________________________________
void GET_palette_current_animation()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].palette_current_animation          :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_palette_current_animation();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_palette_current_animation();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_palette_current_frame()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].palette_current_frame              :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_palette_current_frame();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_palette_current_frame();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_palette_timer()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].palette_timer                      :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_palette_timer();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_palette_timer();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_movement_animate()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (y/n) for YES or NO]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].movement_animate                   :  "; cin>>chk_chr;
 if(chk_chr != 'Y' && chk_chr != 'y' && chk_chr != 'N' && chk_chr != 'n')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (y/n) for YES or NO."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  GET_movement_animate();
 }
 if(chk_chr == 'Y' || chk_chr == 'y')  final_num = 1;
 if(chk_chr == 'N' || chk_chr == 'n')  final_num = 0;
 return;
}
//______________________________________________________________________________________________________________________
void GET_movement_loop()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (y/n) for YES or NO]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].movement_loop                      :  "; cin>>chk_chr;
 if(chk_chr != 'Y' && chk_chr != 'y' && chk_chr != 'N' && chk_chr != 'n')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (y/n) for YES or NO."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  GET_movement_loop();
 }
 if(chk_chr == 'Y' || chk_chr == 'y')  final_num = 1;
 if(chk_chr == 'N' || chk_chr == 'n')  final_num = 0;
 return;
}
//______________________________________________________________________________________________________________________
void GET_movement_current_animation()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].movement_current_animation         :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_movement_current_animation();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_movement_current_animation();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_movement_current_frame()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].movement_current_frame             :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_movement_current_frame();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_movement_current_frame();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_movement_timer_X()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].movement_timer[X]                  :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_movement_timer_X();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_movement_timer_X();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_movement_timer_Y()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].movement_timer[Y]                  :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_movement_timer_Y();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_movement_timer_Y();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_movement_timer_Z()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].movement_timer[Z]                  :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_movement_timer_Z();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_movement_timer_Z();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_rotation_animate()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (y/n) for YES or NO]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].rotation_animate                   :  "; cin>>chk_chr;
 if(chk_chr != 'Y' && chk_chr != 'y' && chk_chr != 'N' && chk_chr != 'n')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (y/n) for YES or NO."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  GET_rotation_animate();
 }
 if(chk_chr == 'Y' || chk_chr == 'y')  final_num = 1;
 if(chk_chr == 'N' || chk_chr == 'n')  final_num = 0;
 return;
}
//______________________________________________________________________________________________________________________
void GET_rotation_loop()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (y/n) for YES or NO]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].rotation_loop                      :  "; cin>>chk_chr;
 if(chk_chr != 'Y' && chk_chr != 'y' && chk_chr != 'N' && chk_chr != 'n')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (y/n) for YES or NO."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  GET_rotation_loop();
 }
 if(chk_chr == 'Y' || chk_chr == 'y')  final_num = 1;
 if(chk_chr == 'N' || chk_chr == 'n')  final_num = 0;
 return;
}
//______________________________________________________________________________________________________________________
void GET_rotation_current_animation()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].rotation_current_animation         :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_rotation_current_animation();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_rotation_current_animation();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_rotation_current_frame()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].rotation_current_frame             :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_rotation_current_frame();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_rotation_current_frame();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_rotation_timer_X()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].rotation_timer[X]                  :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_rotation_timer_X();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_rotation_timer_X();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_rotation_timer_Y()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].rotation_timer[Y]                  :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_rotation_timer_Y();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_rotation_timer_Y();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_rotation_timer_Z()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].rotation_timer[Z]                  :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_rotation_timer_Z();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_rotation_timer_Z();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_scaling_animate()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (y/n) for YES or NO]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].scaling_animate                    :  "; cin>>chk_chr;
 if(chk_chr != 'Y' && chk_chr != 'y' && chk_chr != 'N' && chk_chr != 'n')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (y/n) for YES or NO."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  GET_scaling_animate();
 }
 if(chk_chr == 'Y' || chk_chr == 'y')  final_num = 1;
 if(chk_chr == 'N' || chk_chr == 'n')  final_num = 0;
 return;
}
//______________________________________________________________________________________________________________________
void GET_scaling_loop()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (y/n) for YES or NO]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].scaling_loop                       :  "; cin>>chk_chr;
 if(chk_chr != 'Y' && chk_chr != 'y' && chk_chr != 'N' && chk_chr != 'n')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (y/n) for YES or NO."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  GET_scaling_loop();
 }
 if(chk_chr == 'Y' || chk_chr == 'y')  final_num = 1;
 if(chk_chr == 'N' || chk_chr == 'n')  final_num = 0;
 return;
}
//______________________________________________________________________________________________________________________
void GET_scaling_current_animation()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].scaling_current_animation          :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_scaling_current_animation();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_scaling_current_animation();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_scaling_current_frame()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].scaling_current_frame              :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_scaling_current_frame();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_scaling_current_frame();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_scaling_timer_X()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].scaling_timer[X]                   :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_scaling_timer_X();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_scaling_timer_X();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_scaling_timer_Y()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].scaling_timer[Y]                   :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_scaling_timer_Y();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_scaling_timer_Y();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_position_X()
{
 cout<<endl;
 cout<<"[FIXED between -9999.9999 and 9999.9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].position[X]                        :  "; cin>>final_num;
 if(final_num < -9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_position_X();
 }
 if(final_num > 9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_position_X();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_position_Y()
{
 cout<<endl;
 cout<<"[FIXED between -9999.9999 and 9999.9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].position[Y]                        :  "; cin>>final_num;
 if(final_num < -9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_position_Y();
 }
 if(final_num > 9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_position_Y();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_position_Z()
{
 cout<<endl;
 cout<<"[FIXED between -9999.9999 and 9999.9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].position[Z]                        :  "; cin>>final_num;
 if(final_num < -9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_position_Z();
 }
 if(final_num > 9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_position_Z();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_angle_X()
{
 cout<<endl;
 cout<<"[FIXED between -9999.9999 and 9999.9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].angle[X]                           :  "; cin>>final_num;
 if(final_num < -9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_angle_X();
 }
 if(final_num > 9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_angle_X();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_angle_Y()
{
 cout<<endl;
 cout<<"[FIXED between -9999.9999 and 9999.9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].angle[Y]                           :  "; cin>>final_num;
 if(final_num < -9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_angle_Y();
 }
 if(final_num > 9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_angle_Y();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_angle_Z()
{
 cout<<endl;
 cout<<"[FIXED between -9999.9999 and 9999.9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].angle[Z]                           :  "; cin>>final_num;
 if(final_num < -9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_angle_Z();
 }
 if(final_num > 9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_angle_Z();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_scale_X()
{
 cout<<endl;
 cout<<"[FIXED between -9999.9999 and 9999.9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].scale[X]                           :  "; cin>>final_num;
 if(final_num < -9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_scale_X();
 }
 if(final_num > 9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_scale_X();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_scale_Y()
{
 cout<<endl;
 cout<<"[FIXED between -9999.9999 and 9999.9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].scale[Y]                           :  "; cin>>final_num;
 if(final_num < -9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_scale_Y();
 }
 if(final_num > 9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_scale_Y();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_current_scrollplane_map()
{
 cout<<endl;
 cout<<"[Integer between -1 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].current_scrollplane_map            :  "; cin>>final_num;
 if(final_num < -1)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -1."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -2;
  GET_current_scrollplane_map();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -2;
  GET_current_scrollplane_map();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_current_scrollplane_cel()
{
 cout<<endl;
 cout<<"[Integer between -1 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].current_scrollplane_cel            :  "; cin>>final_num;
 if(final_num < -1)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -1."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -2;
  GET_current_scrollplane_cel();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -2;
  GET_current_scrollplane_cel();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_current_scrollplane_palette()
{
 cout<<endl;
 cout<<"[Integer between -1 and 9999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].current_scrollplane_palette        :  "; cin>>final_num;
 if(final_num < -1)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -1."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -2;
  GET_current_scrollplane_palette();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -2;
  GET_current_scrollplane_palette();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_scrollplane_map_memory_address()
{
 cout<<endl;
 cout<<"[Integer between 0 and 99999999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].scrollplane_map_memory_address     :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_scrollplane_map_memory_address();
 }
 if(final_num > 99999999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 99999999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_scrollplane_map_memory_address();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_scrollplane_cel_memory_address()
{
 cout<<endl;
 cout<<"[Integer between 0 and 99999999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].scrollplane_cel_memory_address     :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_scrollplane_cel_memory_address();
 }
 if(final_num > 99999999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 99999999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_scrollplane_cel_memory_address();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_scrollplane_palette_memory_address()
{
 cout<<endl;
 cout<<"[Integer between 0 and 99999999]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].scrollplane_palette_memory_address :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_scrollplane_palette_memory_address();
 }
 if(final_num > 99999999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 99999999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_scrollplane_palette_memory_address();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_address_multiplier()
{
 cout<<endl;
 cout<<"[Integer between 1 and 9999]"<<endl;
 cout<<">> ["<<temp1<<"] memory address multiplier                           :  "; cin>>final_num;
 if(final_num < 1)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 1."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_address_multiplier();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_address_multiplier();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_use_palette()
{
 cout<<endl;
 cout<<"[Integer between 0 and 7]"<<endl;
 cout<<">> SCROLLPLANE_BASIC["<<temp1<<"].use_palette                        :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_use_palette();
 }
 if(final_num > 7)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 7."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_use_palette();
 }
 return;
}
//______________________________________________________________________________________________________________________
// END OF PROGRAM!!
//______________________________________________________________________________________________________________________

