#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <fstream.h>
//______________________________________________________________________________________________________________________
//  Global declarations are defined below:
//______________________________________________________________________________________________________________________
ifstream input_file;
ofstream output_file;
int num_of_sprites, temp1;
double final_num;
char finalfile[30], file_pos, chk_chr;
//______________________________________________________________________________________________________________________
//  Function prototypes are defined below:
//______________________________________________________________________________________________________________________
void GET_num_of_sprites();
void GET_show_sprite();   
void GET_image2D_number();  
void GET_position_X();
void GET_position_Y();
void GET_position_Z();
void GET_angle();
void GET_scale();
void GET_z_distance_affect();
void GET_clipping_check();
void GET_clipping_left_boundary();
void GET_clipping_right_boundary();
void GET_clipping_top_boundary();
void GET_clipping_bottom_boundary();
void GET_clipping_front_boundary();
void GET_clipping_back_boundary();
//______________________________________________________________________________________________________________________
//  The Main Program is below:
//______________________________________________________________________________________________________________________
int main()
{
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"   Elbesem Engine :  SPRITE2D_32K_BASIC Tool - v1.0"<<endl;
 cout<<endl;
 cout<<"   - E2 data type :  SPRITE2D_32K_BASIC."<<endl;
 cout<<"   - Coded by     :  Zaksund."<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<endl;
 cout<<"[String between 1 and 30 characters in length (include extension, ex:  '.txt')]"<<endl;
 cout<<">> E2 output file name :  "; cin>>finalfile;
 output_file.open("zdump");
 GET_num_of_sprites(); final_num = num_of_sprites *.001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 for(temp1 = 0; temp1 != num_of_sprites; temp1++)
 {
  cout<<"| SPRITE2D_32K_BASIC # ("<<temp1<<" / "<<num_of_sprites - 1<<") |"<<endl;
  output_file.unsetf(ios::showpos);
  GET_show_sprite(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  GET_image2D_number(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_position_X(); final_num *= .001; output_file.setf(ios::showpos|ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;
  GET_position_Y(); final_num *= .001; output_file.setf(ios::showpos|ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;
  GET_position_Z(); final_num *= .001; output_file.setf(ios::showpos|ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;
  GET_angle(); final_num *= .001; output_file.setf(ios::showpos|ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;
  GET_scale(); final_num *= .001; output_file.setf(ios::showpos|ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;
  output_file.unsetf(ios::showpos);
  GET_z_distance_affect(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  GET_clipping_check(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  GET_clipping_left_boundary(); final_num *= .001; output_file.setf(ios::showpos|ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;
  GET_clipping_right_boundary(); final_num *= .001; output_file.setf(ios::showpos|ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;
  GET_clipping_top_boundary(); final_num *= .001; output_file.setf(ios::showpos|ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;
  GET_clipping_bottom_boundary(); final_num *= .001; output_file.setf(ios::showpos|ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;
  GET_clipping_front_boundary(); final_num *= .001; output_file.setf(ios::showpos|ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;
  GET_clipping_back_boundary(); final_num *= .001; output_file.setf(ios::showpos|ios::fixed|ios::showpoint);output_file<<setw(8)<<setprecision(7)<<final_num;
  cout<<"______________________________________________________________________________"<<endl;
 }
 cout<<"______________________________________________________________________________"<<endl;
 file_pos = '.';
 cout<<endl;
 cout<<".. removing periods (please wait) ..";
 output_file.close(); input_file.open("zdump"); output_file.open(finalfile);
 while(!input_file.eof())
 {
  if(file_pos != '.')
   output_file<<file_pos;
  input_file>>file_pos;
 }
 input_file.close(); output_file.close();
 cout<<endl; cout<<endl;
 cout<<".. FILE CREATION COMPLETED SUCCESSFULLY!!"<<endl;
 cout<<".. '"<<finalfile<<"'"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 system("PAUSE"); return 0;
}
//______________________________________________________________________________________________________________________
//  Functions are defined below:
//______________________________________________________________________________________________________________________
void GET_num_of_sprites()
{
 cout<<endl;
 cout<<"[Integer between 1 and 9999]"<<endl;
 cout<<">> Number of SPRITE2D_32Ks                        :  "; cin>>num_of_sprites;
 if(num_of_sprites < 1)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 1."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  num_of_sprites = 0;
  GET_num_of_sprites();
 }
 if(num_of_sprites > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  num_of_sprites = 0;
  GET_num_of_sprites();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_show_sprite()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (y/n) for YES or NO]"<<endl;
 cout<<">> SPRITE2D_32K_BASIC["<<temp1<<"].show_sprite              :  "; cin>>chk_chr;
 if(chk_chr != 'Y' && chk_chr != 'y' && chk_chr != 'N' && chk_chr != 'n')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (y/n) for YES or NO."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  GET_show_sprite();
 }
 if(chk_chr == 'Y' || chk_chr == 'y')  final_num = 1;
 if(chk_chr == 'N' || chk_chr == 'n')  final_num = 0;
 return;
}
//______________________________________________________________________________________________________________________
void GET_image2D_number()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SPRITE2D_32K_BASIC["<<temp1<<"].image2D_number           :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_image2D_number();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_image2D_number();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_position_X()
{
 cout<<endl;
 cout<<"[FIXED between -9999.9999 and 9999.9999]"<<endl;
 cout<<">> SPRITE2D_32K_BASIC["<<temp1<<"].position[X]              :  "; cin>>final_num;
 if(final_num < -9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_position_X();
 }
 if(final_num > 9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_position_X();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_position_Y()
{
 cout<<endl;
 cout<<"[FIXED between -9999.9999 and 9999.9999]"<<endl;
 cout<<">> SPRITE2D_32K_BASIC["<<temp1<<"].position[Y]              :  "; cin>>final_num;
 if(final_num < -9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_position_Y();
 }
 if(final_num > 9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_position_Y();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_position_Z()
{
 cout<<endl;
 cout<<"[FIXED between -9999.9999 and 9999.9999]"<<endl;
 cout<<">> SPRITE2D_32K_BASIC["<<temp1<<"].position[Z]              :  "; cin>>final_num;
 if(final_num < -9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_position_Z();
 }
 if(final_num > 9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_position_Z();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_angle()
{
 cout<<endl;
 cout<<"[FIXED between -9999.9999 and 9999.9999]"<<endl;
 cout<<">> SPRITE2D_32K_BASIC["<<temp1<<"].angle                    :  "; cin>>final_num;
 if(final_num < -9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_angle();
 }
 if(final_num > 9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_angle();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_scale()
{
 cout<<endl;
 cout<<"[FIXED between -9999.9999 and 9999.9999]"<<endl;
 cout<<">> SPRITE2D_32K_BASIC["<<temp1<<"].scale                    :  "; cin>>final_num;
 if(final_num < -9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_scale();
 }
 if(final_num > 9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_scale();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_z_distance_affect()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (y/n) for YES or NO]"<<endl;
 cout<<">> SPRITE2D_32K_BASIC["<<temp1<<"].z_distance_affect        :  "; cin>>chk_chr;
 if(chk_chr != 'Y' && chk_chr != 'y' && chk_chr != 'N' && chk_chr != 'n')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (y/n) for YES or NO."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  chk_chr = '|';
  GET_z_distance_affect();
 }
 if(chk_chr == 'Y' || chk_chr == 'y')  final_num = 1;
 if(chk_chr == 'N' || chk_chr == 'n')  final_num = 0;
 return;
}
//______________________________________________________________________________________________________________________
void GET_clipping_check()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (y/n) for YES or NO]"<<endl;
 cout<<">> SPRITE2D_32K_BASIC["<<temp1<<"].clipping_check           :  "; cin>>chk_chr;
 if(chk_chr != 'Y' && chk_chr != 'y' && chk_chr != 'N' && chk_chr != 'n')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (y/n) for YES or NO."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  chk_chr = '|';
  GET_clipping_check();
 }
 if(chk_chr == 'Y' || chk_chr == 'y')  final_num = 1;
 if(chk_chr == 'N' || chk_chr == 'n')  final_num = 0;
 return;
}
//______________________________________________________________________________________________________________________
void GET_clipping_left_boundary()
{
 cout<<endl;
 cout<<"[FIXED between -9999.9999 and 9999.9999]"<<endl;
 cout<<">> SPRITE2D_32K_BASIC["<<temp1<<"].clipping_left_boundary   :  "; cin>>final_num;
 if(final_num < -9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_clipping_left_boundary();
 }
 if(final_num > 9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_clipping_left_boundary();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_clipping_right_boundary()
{
 cout<<endl;
 cout<<"[FIXED between -9999.9999 and 9999.9999]"<<endl;
 cout<<">> SPRITE2D_32K_BASIC["<<temp1<<"].clipping_right_boundary  :  "; cin>>final_num;
 if(final_num < -9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_clipping_right_boundary();
 }
 if(final_num > 9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_clipping_right_boundary();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_clipping_top_boundary()
{
 cout<<endl;
 cout<<"[FIXED between -9999.9999 and 9999.9999]"<<endl;
 cout<<">> SPRITE2D_32K_BASIC["<<temp1<<"].clipping_top_boundary    :  "; cin>>final_num;
 if(final_num < -9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_clipping_top_boundary();
 }
 if(final_num > 9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_clipping_top_boundary();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_clipping_bottom_boundary()
{
 cout<<endl;
 cout<<"[FIXED between -9999.9999 and 9999.9999]"<<endl;
 cout<<">> SPRITE2D_32K_BASIC["<<temp1<<"].clipping_bottom_boundary :  "; cin>>final_num;
 if(final_num < -9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_clipping_bottom_boundary();
 }
 if(final_num > 9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_clipping_bottom_boundary();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_clipping_front_boundary()
{
 cout<<endl;
 cout<<"[FIXED between -9999.9999 and 9999.9999]"<<endl;
 cout<<">> SPRITE2D_32K_BASIC["<<temp1<<"].clipping_front_boundary  :  "; cin>>final_num;
 if(final_num < -9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_clipping_front_boundary();
 }
 if(final_num > 9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_clipping_front_boundary();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_clipping_back_boundary()
{
 cout<<endl;
 cout<<"[FIXED between -9999.9999 and 9999.9999]"<<endl;
 cout<<">> SPRITE2D_32K_BASIC["<<temp1<<"].clipping_back_boundary   :  "; cin>>final_num;
 if(final_num < -9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is -9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_clipping_back_boundary();
 }
 if(final_num > 9999.9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999.9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = 0;
  GET_clipping_back_boundary();
 }
 return;
}
//______________________________________________________________________________________________________________________
// END OF PROGRAM!!
//______________________________________________________________________________________________________________________
