#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <fstream.h>
//______________________________________________________________________________________________________________________
//  Global declarations are defined below:
//______________________________________________________________________________________________________________________
ifstream input_file;
ofstream output_file;
int num_of_sprites, temp1;
double final_num;
char finalfile[30], file_pos, chk_chr;
//______________________________________________________________________________________________________________________
//  Function prototypes are defined below:
//______________________________________________________________________________________________________________________
void GET_num_of_sprites();
void GET_show_sprite();   
void GET_frame_animate();
void GET_frame_loop();
void GET_frame_current_animation();
void GET_frame_current_frame();
void GET_frame_timer();
//______________________________________________________________________________________________________________________
//  The Main Program is below:
//______________________________________________________________________________________________________________________
int main()
{
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"   Elbesem Engine :  SPRITE3D_TEXTURE Tool - v1.0"<<endl;
 cout<<endl;
 cout<<"   - E2 data type :  SPRITE3D_TEXTURE."<<endl;
 cout<<"   - Coded by     :  Zaksund."<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<endl;
 cout<<"[String between 1 and 30 characters in length (include extension, ex:  '.txt')]"<<endl;
 cout<<">> E2 output file name :  "; cin>>finalfile;
 output_file.open("zdump");
 GET_num_of_sprites(); final_num = num_of_sprites *.001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 for(temp1 = 0; temp1 != num_of_sprites; temp1++)
 {
  cout<<"| SPRITE3D_TEXTURE # ("<<temp1<<" / "<<num_of_sprites - 1<<") |"<<endl;
  output_file.unsetf(ios::showpos);
  GET_show_sprite(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  GET_frame_animate(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  GET_frame_loop(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  GET_frame_current_animation(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_frame_current_frame(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_frame_timer(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  cout<<"______________________________________________________________________________"<<endl;
 }
 cout<<"______________________________________________________________________________"<<endl;
 file_pos = '.';
 cout<<endl;
 cout<<".. removing periods (please wait) ..";
 output_file.close(); input_file.open("zdump"); output_file.open(finalfile);
 while(!input_file.eof())
 {
  if(file_pos != '.')
   output_file<<file_pos;
  input_file>>file_pos;
 }
 input_file.close(); output_file.close();
 cout<<endl; cout<<endl;
 cout<<".. FILE CREATION COMPLETED SUCCESSFULLY!!"<<endl;
 cout<<".. '"<<finalfile<<"'"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 system("PAUSE"); return 0;
}
//______________________________________________________________________________________________________________________
//  Functions are defined below:
//______________________________________________________________________________________________________________________
void GET_num_of_sprites()
{
 cout<<endl;
 cout<<"[Integer between 1 and 9999]"<<endl;
 cout<<">> Number of SPRITE3D_TEXTUREs                 :  "; cin>>num_of_sprites;
 if(num_of_sprites < 1)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 1."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  num_of_sprites = 0;
  GET_num_of_sprites();
 }
 if(num_of_sprites > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  num_of_sprites = 0;
  GET_num_of_sprites();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_show_sprite()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (y/n) for YES or NO]"<<endl;
 cout<<">> SPRITE3D_TEXTURE["<<temp1<<"].show_sprite             :  "; cin>>chk_chr;
 if(chk_chr != 'Y' && chk_chr != 'y' && chk_chr != 'N' && chk_chr != 'n')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (y/n) for YES or NO."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  GET_show_sprite();
 }
 if(chk_chr == 'Y' || chk_chr == 'y')  final_num = 1;
 if(chk_chr == 'N' || chk_chr == 'n')  final_num = 0;
 return;
}
//______________________________________________________________________________________________________________________
void GET_frame_animate()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (y/n) for YES or NO]"<<endl;
 cout<<">> SPRITE3D_TEXTURE["<<temp1<<"].frame_animate           :  "; cin>>chk_chr;
 if(chk_chr != 'Y' && chk_chr != 'y' && chk_chr != 'N' && chk_chr != 'n')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (y/n) for YES or NO."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  GET_frame_animate();
 }
 if(chk_chr == 'Y' || chk_chr == 'y')  final_num = 1;
 if(chk_chr == 'N' || chk_chr == 'n')  final_num = 0;
 return;
}
//______________________________________________________________________________________________________________________
void GET_frame_loop()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (y/n) for YES or NO]"<<endl;
 cout<<">> SPRITE3D_TEXTURE["<<temp1<<"].frame_loop              :  "; cin>>chk_chr;
 if(chk_chr != 'Y' && chk_chr != 'y' && chk_chr != 'N' && chk_chr != 'n')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (y/n) for YES or NO."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  GET_frame_loop();
 }
 if(chk_chr == 'Y' || chk_chr == 'y')  final_num = 1;
 if(chk_chr == 'N' || chk_chr == 'n')  final_num = 0;
 return;
}
//______________________________________________________________________________________________________________________
void GET_frame_current_animation()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SPRITE3D_TEXTURE["<<temp1<<"].frame_current_animation :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_frame_current_animation();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_frame_current_animation();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_frame_current_frame()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SPRITE3D_TEXTURE["<<temp1<<"].frame_current_frame     :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_frame_current_frame();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_frame_current_frame();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_frame_timer()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> SPRITE3D_TEXTURE["<<temp1<<"].frame_timer             :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_frame_timer();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_frame_timer();
 }
 return;
}
//______________________________________________________________________________________________________________________
// END OF PROGRAM!!
//______________________________________________________________________________________________________________________
