#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <fstream.h>
//______________________________________________________________________________________________________________________
//  Global declarations are defined below:
//______________________________________________________________________________________________________________________
ifstream input_file;
ofstream output_file;
int num_of_anims, temp1, temp2, total_frames[100];
double final_num;
char finalfile[30], file_pos, chk_chr;
//______________________________________________________________________________________________________________________
//  Function prototypes are defined below:
//______________________________________________________________________________________________________________________
void GET_num_of_anims();
void GET_total_frames();

void GET_animate_frame();
void GET_current_R();
void GET_current_G();
void GET_current_B();
void GET_final_R();
void GET_final_G();
void GET_final_B();
void GET_R_increment();
void GET_G_increment();
void GET_B_increment();
void GET_timer();
void GET_timer_increment();
//______________________________________________________________________________________________________________________
//  The Main Program is below:
//______________________________________________________________________________________________________________________
int main()
{
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"   Elbesem Engine :  FADE_FRAME Tool - v1.0"<<endl;
 cout<<endl;
 cout<<"   - E2 data type :  FADE[].gradient_data."<<endl;
 cout<<"   - Coded by     :  Zaksund."<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<endl;
 cout<<"[String between 1 and 30 characters in length (include extension, ex:  '.txt')]"<<endl;
 cout<<">> E2 output file name :  "; cin>>finalfile;
 output_file.open("zdump");
 GET_num_of_anims(); final_num = num_of_anims *.001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 for(temp1 = 0; temp1 != num_of_anims; temp1++)
 {
  cout<<"| FADE_FRAME # ("<<temp1<<" / "<<num_of_anims - 1<<") |"<<endl;
  GET_total_frames(); final_num = total_frames[temp1] *.001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  cout<<"______________________________________________________________________________"<<endl;
 }
 cout<<"______________________________________________________________________________"<<endl;
 for(temp1 = 0; temp1 != num_of_anims; temp1++)
 {
  for(temp2 = 0; temp2 != total_frames[temp1]; temp2++)
  {
   output_file.unsetf(ios::showpos);
   cout<<"| FADE_FRAME # ("<<temp1<<" / "<<num_of_anims - 1<<") |"<<endl;
   cout<<"| FRAME # ("<<temp2<<" / "<<total_frames[temp1] - 1<<") |"<<endl;

   GET_animate_frame(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
   GET_current_R(); final_num *= .01; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(3)<<setprecision(2)<<final_num;
   GET_current_G(); final_num *= .01; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(3)<<setprecision(2)<<final_num;
   GET_current_B(); final_num *= .01; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(3)<<setprecision(2)<<final_num;
   GET_final_R(); final_num *= .01; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(3)<<setprecision(2)<<final_num;
   GET_final_G(); final_num *= .01; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(3)<<setprecision(2)<<final_num;
   GET_final_B(); final_num *= .01; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(3)<<setprecision(2)<<final_num;
   GET_R_increment(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
   GET_G_increment(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
   GET_B_increment(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
   GET_timer(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
   GET_timer_increment(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
   cout<<"______________________________________________________________________________"<<endl;
  }
  cout<<"______________________________________________________________________________"<<endl;
 }
 file_pos = '.';
 cout<<endl;
 cout<<".. removing periods (please wait) ..";
 output_file.close(); input_file.open("zdump"); output_file.open(finalfile);
 while(!input_file.eof())
 {
  if(file_pos != '.')
   output_file<<file_pos;
  input_file>>file_pos;
 }
 input_file.close(); output_file.close();
 cout<<endl; cout<<endl;
 cout<<".. FILE CREATION COMPLETED SUCCESSFULLY!!"<<endl;
 cout<<".. '"<<finalfile<<"'"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 system("PAUSE"); return 0;
}
//______________________________________________________________________________________________________________________
//  Functions are defined below:
//______________________________________________________________________________________________________________________
void GET_num_of_anims()
{
 cout<<endl;
 cout<<"[Integer between 1 and 9999]"<<endl;
 cout<<">> Number of FADE_FRAMEs         :  "; cin>>num_of_anims;
 if(num_of_anims < 1)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 1."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  num_of_anims = 0;
  GET_num_of_anims();
 }
 if(num_of_anims > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  num_of_anims = 0;
  GET_num_of_anims();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_total_frames()
{
 cout<<endl;
 cout<<"[Integer between 1 and 9999]"<<endl;
 cout<<">> FADE_FRAME["<<temp1<<"].total_frames    :  "; cin>>total_frames[temp1];
 if(total_frames[temp1] < 1)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 1."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  total_frames[temp1] = 0;
  GET_total_frames();
 }
 if(total_frames[temp1] > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  total_frames[temp1] = 0;
  GET_total_frames();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_animate_frame()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (y/n) for YES or NO]"<<endl;
 cout<<">> FADE_FRAME["<<temp1<<"].animate frame   :  "; cin>>chk_chr;
 if(chk_chr != 'Y' && chk_chr != 'y' && chk_chr != 'N' && chk_chr != 'n')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (y/n) for YES or NO."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  GET_animate_frame();
 }
 if(chk_chr == 'Y' || chk_chr == 'y')  final_num = 1;
 if(chk_chr == 'N' || chk_chr == 'n')  final_num = 0;
 return;
}
//______________________________________________________________________________________________________________________
void GET_current_R()
{
 cout<<endl;
 cout<<"[Integer between 257 and 767]"<<endl;
 cout<<">> FADE_FRAME["<<temp1<<"].current_red     :  "; cin>>final_num;
 if(final_num < 257)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 257."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_current_R();
 }
 if(final_num > 767)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 767."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_current_R();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_current_G()
{
 cout<<endl;
 cout<<"[Integer between 257 and 767]"<<endl;
 cout<<">> FADE_FRAME["<<temp1<<"].current_green   :  "; cin>>final_num;
 if(final_num < 257)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 257."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_current_G();
 }
 if(final_num > 767)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 767."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_current_G();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_current_B()
{
 cout<<endl;
 cout<<"[Integer between 257 and 767]"<<endl;
 cout<<">> FADE_FRAME["<<temp1<<"].current_blue    :  "; cin>>final_num;
 if(final_num < 257)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 257."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_current_B();
 }
 if(final_num > 767)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 767."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_current_B();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_final_R()
{
 cout<<endl;
 cout<<"[Integer between 257 and 767]"<<endl;
 cout<<">> FADE_FRAME["<<temp1<<"].final_red       :  "; cin>>final_num;
 if(final_num < 257)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 257."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_final_R();
 }
 if(final_num > 767)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 767."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_final_R();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_final_G()
{
 cout<<endl;
 cout<<"[Integer between 257 and 767]"<<endl;
 cout<<">> FADE_FRAME["<<temp1<<"].final_green     :  "; cin>>final_num;
 if(final_num < 257)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 257."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_final_G();
 }
 if(final_num > 767)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 767."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_final_G();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_final_B()
{
 cout<<endl;
 cout<<"[Integer between 257 and 767]"<<endl;
 cout<<">> FADE_FRAME["<<temp1<<"].final_blue      :  "; cin>>final_num;
 if(final_num < 257)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 257."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_final_B();
 }
 if(final_num > 767)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 767."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_final_B();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_R_increment()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> FADE_FRAME["<<temp1<<"].red_increment   :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_R_increment();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_R_increment();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_G_increment()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> FADE_FRAME["<<temp1<<"].green_increment :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_G_increment();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_G_increment();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_B_increment()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> FADE_FRAME["<<temp1<<"].blue_increment  :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_B_increment();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_B_increment();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_timer()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> FADE_FRAME["<<temp1<<"].timer           :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_timer();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_timer();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_timer_increment()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> FADE_FRAME["<<temp1<<"].timer_increment :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_timer_increment();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_timer_increment();
 }
 return;
}
//______________________________________________________________________________________________________________________
// END OF PROGRAM!!
//______________________________________________________________________________________________________________________
