#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <fstream.h>
//______________________________________________________________________________________________________________________
//  Global declarations are defined below:
//______________________________________________________________________________________________________________________
ifstream input_file;
ofstream output_file;
int num_of_fades, temp1;
double final_num;
char finalfile[30], file_pos, chk_chr;
//______________________________________________________________________________________________________________________
//  Function prototypes are defined below:
//______________________________________________________________________________________________________________________
void GET_num_of_fades();
void GET_show_fade();
void GET_play_animation();
void GET_loop_animation();
void GET_current_frame();
void GET_total_frames();
void GET_use_color_offset();
void GET_timer_X();
void GET_timer_Y();
void GET_timer_Z();
//______________________________________________________________________________________________________________________
//  The Main Program is below:
//______________________________________________________________________________________________________________________
int main()
{
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"   Elbesem Engine :  FADE Tool - v1.0"<<endl;
 cout<<endl;
 cout<<"   - E2 data type :  FADE."<<endl;
 cout<<"   - Coded by     :  Zaksund."<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<endl;
 cout<<"[String between 1 and 30 characters in length (include extension, ex:  '.txt')]"<<endl;
 cout<<">> E2 output file name :   "; cin>>finalfile;
 output_file.open("zdump");
 GET_num_of_fades(); final_num = num_of_fades *.001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 for(temp1 = 0; temp1 != num_of_fades; temp1++)
 {
  cout<<"| FADE # ("<<temp1<<" / "<<num_of_fades - 1<<") |"<<endl;
  output_file.unsetf(ios::showpos);
  GET_show_fade(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  GET_play_animation(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  GET_loop_animation(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  GET_current_frame(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_total_frames(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_use_color_offset(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  GET_timer_X(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_timer_Y(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  GET_timer_Z(); final_num *= .001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
  cout<<"______________________________________________________________________________"<<endl;
 }
 cout<<"______________________________________________________________________________"<<endl;
 file_pos = '.';
 cout<<endl;
 cout<<".. removing periods (please wait) ..";
 output_file.close(); input_file.open("zdump"); output_file.open(finalfile);
 while(!input_file.eof())
 {
  if(file_pos != '.')
   output_file<<file_pos;
  input_file>>file_pos;
 }
 input_file.close(); output_file.close();
 cout<<endl; cout<<endl;
 cout<<".. FILE CREATION COMPLETED SUCCESSFULLY!!"<<endl;
 cout<<".. '"<<finalfile<<"'"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 system("PAUSE"); return 0;
}
//______________________________________________________________________________________________________________________
//  Functions are defined below:
//______________________________________________________________________________________________________________________
void GET_num_of_fades()
{
 cout<<endl;
 cout<<"[Integer between 1 and 9999]"<<endl;
 cout<<">> Number of FADEs          :  "; cin>>num_of_fades;
 if(num_of_fades < 1)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 1."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  num_of_fades = 0;
  GET_num_of_fades();
 }
 if(num_of_fades > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  num_of_fades = 0;
  GET_num_of_fades();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_show_fade()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (y/n) for YES or NO]"<<endl;
 cout<<">> FADE["<<temp1<<"].show_fade        :  "; cin>>chk_chr;
 if(chk_chr != 'Y' && chk_chr != 'y' && chk_chr != 'N' && chk_chr != 'n')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (y/n) for YES or NO."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  GET_show_fade();
 }
 if(chk_chr == 'Y' || chk_chr == 'y')  final_num = 1;
 if(chk_chr == 'N' || chk_chr == 'n')  final_num = 0;
 return;
}
//______________________________________________________________________________________________________________________
void GET_play_animation()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (y/n) for YES or NO]"<<endl;
 cout<<">> FADE["<<temp1<<"].play_animation   :  "; cin>>chk_chr;
 if(chk_chr != 'Y' && chk_chr != 'y' && chk_chr != 'N' && chk_chr != 'n')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (y/n) for YES or NO."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  GET_play_animation();
 }
 if(chk_chr == 'Y' || chk_chr == 'y')  final_num = 1;
 if(chk_chr == 'N' || chk_chr == 'n')  final_num = 0;
 return;
}
//______________________________________________________________________________________________________________________
void GET_loop_animation()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (y/n) for YES or NO]"<<endl;
 cout<<">> FADE["<<temp1<<"].loop_animation   :  "; cin>>chk_chr;
 if(chk_chr != 'Y' && chk_chr != 'y' && chk_chr != 'N' && chk_chr != 'n')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (y/n) for YES or NO."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  GET_loop_animation();
 }
 if(chk_chr == 'Y' || chk_chr == 'y')  final_num = 1;
 if(chk_chr == 'N' || chk_chr == 'n')  final_num = 0;
 return;
}
//______________________________________________________________________________________________________________________
void GET_current_frame()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> FADE["<<temp1<<"].current_frame    :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_current_frame();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_current_frame();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_total_frames()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999]"<<endl;
 cout<<">> FADE["<<temp1<<"].total_frames     :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_total_frames();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_total_frames();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_use_color_offset()
{
 chk_chr = '|';
 cout<<endl;
 cout<<"[Character of (a/b) for offset A or offset B]"<<endl;
 cout<<">> FADE["<<temp1<<"].use_color_offset :  "; cin>>chk_chr;
 if(chk_chr != 'A' && chk_chr != 'a' && chk_chr != 'B' && chk_chr != 'b')
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  You must answer (a/b) for offset A or offset B."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  GET_use_color_offset();
 }
 if(chk_chr == 'B' || chk_chr == 'b')  final_num = 1;
 if(chk_chr == 'A' || chk_chr == 'a')  final_num = 0;
 return;
}
//______________________________________________________________________________________________________________________
void GET_timer_X()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999 (Normally, this would be 0)]"<<endl;
 cout<<">> FADE["<<temp1<<"].timer[X]         :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_timer_X();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_timer_X();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_timer_Y()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999 (Normally, this would be 0)]"<<endl;
 cout<<">> FADE["<<temp1<<"].timer[Y]         :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_timer_Y();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_timer_Y();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_timer_Z()
{
 cout<<endl;
 cout<<"[Integer between 0 and 9999 (Normally, this would be 0)]"<<endl;
 cout<<">> FADE["<<temp1<<"].timer[Z]         :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_timer_Z();
 }
 if(final_num > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_timer_Z();
 }
 return;
}
//______________________________________________________________________________________________________________________
// END OF PROGRAM!!
//______________________________________________________________________________________________________________________
