#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <fstream.h>
//______________________________________________________________________________________________________________________
//  Global declarations are defined below:
//______________________________________________________________________________________________________________________
ifstream input_file;
ofstream output_file;
int num_of_sprites, sprite_sizes[100][2], num_1, num_2, num_3, num_4, total_nums, total_sprite_sizes = 0, temp1, temp2, temp3, temp4, temp5;
char openfile[100][30], finalfile[30], file_pos;
double final_num;
//______________________________________________________________________________________________________________________
//  Function prototypes are defined below:
//______________________________________________________________________________________________________________________
void GET_num_of_sprites();
void GET_sprite_width();
void GET_sprite_height();
int asc_chk(char num);
//______________________________________________________________________________________________________________________
//  The Main Program is below:
//______________________________________________________________________________________________________________________
int main()
{
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"   Elbesem Engine :  IMAGE2D_32K Tool - v1.0"<<endl;
 cout<<endl;
 cout<<"   - E2 data type :  IMAGE2D_32K."<<endl;
 cout<<"   - Coded by     :  Zaksund."<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<endl;
 cout<<"!! Please make sure you've already:"<<endl;
 cout<<"   *  Converted the 2D images using 'ssconv.exe'."<<endl;
 cout<<"   *  Saved your files as '.bin' files."<<endl;
 cout<<endl;
 cout<<"!! When complete, make sure to:"<<endl;
 cout<<"   *  Use 'Find/Replace' in a text editor to convert any transparent pixels"<<endl;
 cout<<"      to '00000'."<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<endl;
 cout<<"[String between 1 and 30 characters in length (include extension, ex:  '.txt')]"<<endl;
 cout<<">> E2 output file name :  "; cin>>finalfile;
 GET_num_of_sprites(); output_file.open("zdump"); final_num = num_of_sprites *.001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 for(temp1 = 0; temp1 != num_of_sprites; temp1++)
 {
  cout<<"| IMAGE2D_32K # ("<<temp1<<" / "<<num_of_sprites - 1<<") |"<<endl;
  cout<<endl;
  cout<<"[String between 1 and 30 characters in length (include '.bin' extension)]"<<endl;
  cout<<">> IMAGE2D_32K '.bin' file name   :  "; cin>>openfile[temp1]; input_file.open(openfile[temp1]);
  GET_sprite_width();
  GET_sprite_height();
  cout<<endl;
  cout<<".. IMAGE2D_32K #["<<temp1<<"] Total Size = "<<sprite_sizes[temp1][0] * sprite_sizes[temp1][1]<<"!!"<<endl;
  cout<<"______________________________________________________________________________"<<endl;
  final_num = sprite_sizes[temp1][0] * .01; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(3)<<setprecision(2)<<final_num;
  final_num = sprite_sizes[temp1][1] * .01; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(3)<<setprecision(2)<<final_num;
  input_file.close();
 }
 cout<<"______________________________________________________________________________"<<endl;
 cout<<".. now converting   (please wait) .."<<endl;

 for(temp1 = 0; temp1 != num_of_sprites; temp1++)
 {
  input_file.open(openfile[temp1]);
  if(input_file == 0x0)
  {
   cout<<endl;
   cout<<"------------------------------------------------------------------------------"<<endl;
   cout<<"[!!ERROR!!]:  The file:  '"<<openfile[temp1]<<"' couldn't be found."<<endl;
   cout<<"[!!ERROR!!]:  Please check the file name and location, and try again."<<endl;
   cout<<"------------------------------------------------------------------------------"<<endl;
   cout<<endl;
   cout<<".. FILE CREATION FAILED!!"<<endl;
   cout<<".. '"<<finalfile<<"'"<<endl;
   cout<<"______________________________________________________________________________"<<endl;
   cout<<"______________________________________________________________________________"<<endl;
   system("PAUSE");
   return(0);
  }
  while(file_pos != '{')
  {
   input_file>>file_pos;
  }
  for(temp2 = 0; temp2 != sprite_sizes[temp1][0] * sprite_sizes[temp1][1]; temp2++)
  {
    while(file_pos != 'x')
    {
     input_file>>file_pos;
    }
    input_file>>file_pos; num_1 = (int)file_pos; temp4 = asc_chk(num_1); num_1 = temp4; num_1 = (num_1 * (16*16*16));
    input_file>>file_pos; num_2 = (int)file_pos; temp4 = asc_chk(num_2); num_2 = temp4; num_2 = (num_2 * (16*16));
    input_file>>file_pos; num_3 = (int)file_pos; temp4 = asc_chk(num_3); num_3 = temp4; num_3 = (num_3 * (16));
    input_file>>file_pos; num_4 = (int)file_pos; temp4 = asc_chk(num_4); num_4 = temp4; num_4 = (num_4);

    total_nums = num_1 + num_2 + num_3 + num_4; final_num = total_nums * .0001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(5)<<setprecision(4)<<final_num; file_pos = '.';
  }
  input_file.close();
 }
 cout<<endl;
 cout<<".. removing periods (please wait) ..";
 output_file.close(); input_file.open("zdump"); output_file.open(finalfile);

 while(!input_file.eof())
 {
  if(file_pos != '.')
   output_file<<file_pos;
  input_file>>file_pos;
 }
 input_file.close(); output_file.close();
 cout<<endl; cout<<endl;
 cout<<".. FILE CREATION COMPLETED SUCCESSFULLY!!"<<endl;
 cout<<".. '"<<finalfile<<"'"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 system("PAUSE"); return 0;
}
//______________________________________________________________________________________________________________________
//  Functions are defined below:
//______________________________________________________________________________________________________________________
void GET_num_of_sprites()
{
 cout<<endl;
 cout<<"[Integer between 1 and 9999]"<<endl;
 cout<<">> Number of IMAGE2D_32Ks         :  "; cin>>num_of_sprites;
 if(num_of_sprites < 1)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 1."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  num_of_sprites = 0;
  GET_num_of_sprites();
 }
 if(num_of_sprites > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  num_of_sprites = 0;
  GET_num_of_sprites();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_sprite_width()
{
 cout<<endl;
 cout<<"[Integer between 8 and 312 (must be a multiple of 8, e.g. 8, 16, 24, 32...312)]"<<endl;
 cout<<">> IMAGE2D_32K["<<temp1<<"].horizontal_size :  "; cin>>sprite_sizes[temp1][0];
 if(sprite_sizes[temp1][0] < 8)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 8."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  sprite_sizes[temp1][0] = 0;
  GET_sprite_width();
 }
 if(sprite_sizes[temp1][0] > 312)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 312."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  sprite_sizes[temp1][0] = 0;
  GET_sprite_width();
 }
 if(sprite_sizes[temp1][0] != 8   &&
    sprite_sizes[temp1][0] != 16  &&
    sprite_sizes[temp1][0] != 24  &&
    sprite_sizes[temp1][0] != 32  &&
    sprite_sizes[temp1][0] != 40  &&
    sprite_sizes[temp1][0] != 48  &&
    sprite_sizes[temp1][0] != 56  &&
    sprite_sizes[temp1][0] != 64  &&
    sprite_sizes[temp1][0] != 72  &&
    sprite_sizes[temp1][0] != 80  &&
    sprite_sizes[temp1][0] != 88  &&
    sprite_sizes[temp1][0] != 96  &&
    sprite_sizes[temp1][0] != 104 &&
    sprite_sizes[temp1][0] != 112 &&
    sprite_sizes[temp1][0] != 120 &&
    sprite_sizes[temp1][0] != 128 &&
    sprite_sizes[temp1][0] != 136 &&
    sprite_sizes[temp1][0] != 144 &&
    sprite_sizes[temp1][0] != 152 &&
    sprite_sizes[temp1][0] != 160 &&
    sprite_sizes[temp1][0] != 168 &&
    sprite_sizes[temp1][0] != 176 &&
    sprite_sizes[temp1][0] != 184 &&
    sprite_sizes[temp1][0] != 192 &&
    sprite_sizes[temp1][0] != 200 &&
    sprite_sizes[temp1][0] != 208 &&
    sprite_sizes[temp1][0] != 216 &&
    sprite_sizes[temp1][0] != 224 &&
    sprite_sizes[temp1][0] != 232 &&
    sprite_sizes[temp1][0] != 240 &&
    sprite_sizes[temp1][0] != 248 &&
    sprite_sizes[temp1][0] != 256 &&
    sprite_sizes[temp1][0] != 264 &&
    sprite_sizes[temp1][0] != 272 &&
    sprite_sizes[temp1][0] != 280 &&
    sprite_sizes[temp1][0] != 288 &&
    sprite_sizes[temp1][0] != 296 &&
    sprite_sizes[temp1][0] != 304 &&
    sprite_sizes[temp1][0] != 312)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  That value is not a multiple of 8."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  sprite_sizes[temp1][0] = 0;
  GET_sprite_width();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_sprite_height()
{
 cout<<endl;
 cout<<"[Integer between 1 and 312]"<<endl;
 cout<<">> IMAGE2D_32K["<<temp1<<"].vertical_size   :  "; cin>>sprite_sizes[temp1][1];
 if(sprite_sizes[temp1][1] < 1)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 1."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  sprite_sizes[temp1][1] = 0;
  GET_sprite_height();
 }
 if(sprite_sizes[temp1][1] > 312)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 312."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  sprite_sizes[temp1][1] = 0;
  GET_sprite_height();
 }
 return;
}
//______________________________________________________________________________________________________________________
int asc_chk(char num)
{
 int temp1;
 temp1 = (int)num;
 switch(temp1)
 {
  case 48:
   temp1 = 0;
   break;
  case 49:
   temp1 = 1;
   break;
  case 50:
   temp1 = 2;
   break;
  case 51:
   temp1 = 3;
   break;
  case 52:
   temp1 = 4;
   break;
  case 53:
   temp1 = 5;
   break;
  case 54:
   temp1 = 6;
   break;
  case 55:
   temp1 = 7;
   break;
  case 56:
   temp1 = 8;
   break;
  case 57:
   temp1 = 9;
   break;
  case 65:
   temp1 = 10;
   break;
  case 66:
   temp1 = 11;
   break;
  case 67:
   temp1 = 12;
   break;
  case 68:
   temp1 = 13;
   break;
  case 69:
   temp1 = 14;
   break;
  case 70:
   temp1 = 15;
   break;
  case 97:
   temp1 = 10;
   break;
  case 98:
   temp1 = 11;
   break;
  case 99:
   temp1 = 12;
   break;
  case 100:
   temp1 = 13;
   break;
  case 101:
   temp1 = 14;
   break;
  case 102:
   temp1 = 15;
   break;
 }
 return(temp1);
}
//______________________________________________________________________________________________________________________
// END OF PROGRAM!!
//______________________________________________________________________________________________________________________
