#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <fstream.h>
/*
  File Format Explanation:
  ========================
  # of PCM files   (4 digits)
  Channel #        (1 digit)
  _Stereo or _Mono (1 digit)
  16 or 8 bit      (1 digit)
  Pitch            (8 digits)
  Sound size       (8 digits)
  --------------------------------
  Sound data...    (3 digits each)
*/
//______________________________________________________________________________________________________________________
//  Global declarations are defined below:
//______________________________________________________________________________________________________________________
ifstream input_file;
ofstream output_file;
int num_of_sounds;
int temp1, temp2, temp3, num_1, num_2, num_3, num_4;
char openfile[100][30], finalfile[30], file_pos = '.', chk_chr = '.';
double final_num;
//______________________________________________________________________________________________________________________
//  Function prototypes are defined below:
//______________________________________________________________________________________________________________________
void GET_num_of_sounds();
void GET_sound_channel();
int  asc_chk(char num);
//______________________________________________________________________________________________________________________
//  The Main Program is below:
//______________________________________________________________________________________________________________________
int main()
{
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"   Elbesem Engine :  SOUND_PCM Tool - v1.0"<<endl;
 cout<<endl;
 cout<<"   - E2 data type :  SOUND_PCM."<<endl;
 cout<<"   - Coded by     :  Zaksund."<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<endl;
 cout<<"!! Please make sure you've already:"<<endl;
 cout<<"   *  Converted the sound effects using 'RB_SaturnPCM.exe'."<<endl;
 cout<<"   *  Saved your files as '.c' files."<<endl;
 cout<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<endl;
 cout<<"[String between 1 and 30 characters in length (include extension, ex:  '.txt')]"<<endl;
 cout<<">> E2 output file name :  "; cin>>finalfile;
 cout<<endl;
 GET_num_of_sounds(); output_file.open("zdump"); final_num = num_of_sounds *.001; output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(4)<<setprecision(3)<<final_num;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;

 for(temp1 = 0; temp1 != num_of_sounds; temp1++)
 {
  cout<<"| SOUND_PCM# ("<<temp1<<" / "<<num_of_sounds - 1<<") |"<<endl;
  cout<<endl;
  cout<<"[String between 1 and 30 characters in length (include '.c' extension)]"<<endl;
  cout<<">> SOUND_PCM '.c' file name :  "; cin>>openfile[temp1];
  GET_sound_channel(); output_file.setf(ios::fixed|ios::showpoint);output_file<<setw(1)<<setprecision(0)<<final_num;
  cout<<"______________________________________________________________________________"<<endl;
 }
 cout<<"______________________________________________________________________________"<<endl;
 cout<<".. now converting   (please wait) .."<<endl;

 for(temp1 = 0; temp1 != num_of_sounds; temp1++)
 {
  input_file.open(openfile[temp1]);
  temp2 = num_1 = num_2 = num_3 = num_4 = 0;
  if(input_file == 0x0)
  {
   cout<<endl;
   cout<<"------------------------------------------------------------------------------"<<endl;
   cout<<"[!!ERROR!!]:  The file:  '"<<openfile[temp1]<<"' couldn't be found."<<endl;
   cout<<"[!!ERROR!!]:  Please check the file name and location, and try again."<<endl;
   cout<<"------------------------------------------------------------------------------"<<endl;
   cout<<endl;
   cout<<".. FILE CREATION FAILED!!"<<endl;
   cout<<".. '"<<finalfile<<"'"<<endl;
   cout<<"______________________________________________________________________________"<<endl;
   cout<<"______________________________________________________________________________"<<endl;
   system("PAUSE");
   return(0);
  }

  while(file_pos != '{'){input_file>>file_pos;}
  while(file_pos != ';')
  {
   input_file>>file_pos;
   if(file_pos == 'x') temp2++;
  }
  file_pos = '.';
  while(file_pos != '{'){input_file>>file_pos;}
  file_pos = '.';
  while(file_pos != '_'){input_file>>file_pos;}
  input_file>>file_pos;
  if(file_pos == 'M') final_num = (int)0;
  if(file_pos == 'S') final_num = (int)1;
  output_file.setf(ios::fixed|ios::showpoint); output_file<<setw(1)<<setprecision(0)<<final_num;
  file_pos = '.';

  while(file_pos != '_'){input_file>>file_pos;}
  while(file_pos != 'M'){input_file>>file_pos;}
  input_file>>file_pos;
  if(file_pos == '8') final_num = (int)0;
  if(file_pos == '1') final_num = (int)1;
  output_file.setf(ios::fixed|ios::showpoint); output_file<<setw(1)<<setprecision(0)<<final_num;
  file_pos = '.';

  while(file_pos != 'x'){input_file>>file_pos;}
  file_pos = '.';

  input_file>>file_pos;
  num_1 = (int)file_pos; temp3 = asc_chk(num_1); num_1 = temp3; num_1 = (num_1 * 16 * 16 * 16);
  input_file>>file_pos;
  if(file_pos != ' ' && file_pos != ',')
  {
   num_2 = (int)file_pos; temp3 = asc_chk(num_2); num_2 = temp3; num_2 = (num_2 * 16 * 16);
   input_file>>file_pos;
   if(file_pos != ' ' && file_pos != ',')
   {
    num_3 = (int)file_pos; temp3 = asc_chk(num_3); num_3 = temp3; num_3 = (num_3 * 16);
    input_file>>file_pos;
    if(file_pos != ' ' && file_pos != ',')
    {
     num_4 = (int)file_pos; temp3 = asc_chk(num_4); num_4 = temp3; num_4 = (num_4);
    }
   }
  }
  input_file.close();
  final_num = num_1 + num_2 + num_3 + num_4; final_num *= .0000001; output_file.setf(ios::fixed|ios::showpoint); output_file<<setw(8)<<setprecision(7)<<final_num;
  final_num = temp2; final_num *= .0000001; output_file.setf(ios::fixed|ios::showpoint); output_file<<setw(8)<<setprecision(7)<<final_num;
 }
 input_file.close();

 for(temp1 = 0; temp1 != num_of_sounds; temp1++)
 {
  input_file.open(openfile[temp1]);
  temp2 = num_1 = num_2 = num_3 = num_4 = 0;
  if(input_file == 0x0)
  {
   cout<<endl;
   cout<<"------------------------------------------------------------------------------"<<endl;
   cout<<"[!!ERROR!!]:  The file:  '"<<openfile[temp1]<<"' couldn't be found."<<endl;
   cout<<"[!!ERROR!!]:  Please check the file name and location, and try again."<<endl;
   cout<<"------------------------------------------------------------------------------"<<endl;
   cout<<endl;
   cout<<".. FILE CREATION FAILED!!"<<endl;
   cout<<".. '"<<finalfile<<"'"<<endl;
   cout<<"______________________________________________________________________________"<<endl;
   cout<<"______________________________________________________________________________"<<endl;
   system("PAUSE");
   return(0);
  }

  while(file_pos != '{'){input_file>>file_pos;}
  while(file_pos != ';')
  {
   input_file>>file_pos;
   if(file_pos == 'x')
   {
    input_file>>file_pos; num_1 = (int)file_pos; temp3 = asc_chk(num_1); num_1 = temp3; num_1 = (num_1 * 16);
    input_file>>file_pos; num_2 = (int)file_pos; temp3 = asc_chk(num_2); num_2 = temp3; num_2 = (num_2);
    final_num = num_1 + num_2; final_num *= .01; output_file.setf(ios::fixed|ios::showpoint); output_file<<setw(3)<<setprecision(2)<<final_num;
    file_pos = '.';
   }
  }
  file_pos = '.';
  input_file.close();
 }
 input_file.close();

 cout<<endl;
 cout<<".. removing periods (please wait) ..";
 output_file.close(); input_file.open("zdump"); output_file.open(finalfile);

 while(!input_file.eof())
 {
  if(file_pos != '.')
   output_file<<file_pos;
  input_file>>file_pos;
 }
 cout<<endl; cout<<endl;
 cout<<".. FILE CREATION COMPLETED SUCCESSFULLY!!"<<endl;
 cout<<".. '"<<finalfile<<"'"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 cout<<"______________________________________________________________________________"<<endl;
 system("PAUSE"); return 0;
}
//______________________________________________________________________________________________________________________
//  Functions are defined below:
//______________________________________________________________________________________________________________________
void GET_num_of_sounds()
{
 cout<<endl;
 cout<<"[Integer between 1 and 9999]"<<endl;
 cout<<">> Number of SOUND_PCMs     :  "; cin>>num_of_sounds;
 if(num_of_sounds < 1)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 1."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  num_of_sounds = 0;
  GET_num_of_sounds();
 }
 if(num_of_sounds > 9999)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 9999."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  num_of_sounds = 0;
  GET_num_of_sounds();
 }
 return;
}
//______________________________________________________________________________________________________________________
void GET_sound_channel()
{
 cout<<endl;
 cout<<"[Integer between 0 and 7]"<<endl;
 cout<<">> SOUND_PCM use channel#   :  "; cin>>final_num;
 if(final_num < 0)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The minimum value allowed is 0."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_sound_channel();
 }
 if(final_num > 7)
 {
  cout<<"------------------------------------------------------------------------------"<<endl;
  cout<<"[!!ERROR!!]:  The maximum value allowed is 7."<<endl;
  cout<<"[!!ERROR!!]:  Please re-input the data."<<endl;
  cout<<"------------------------------------------------------------------------------"<<endl;
  final_num = -1;
  GET_sound_channel();
 }
 return;
}
//______________________________________________________________________________________________________________________
int asc_chk(char num)
{
 int temp1;
 temp1 = (int)num;
 switch(temp1)
 {
  case 48:
   temp1 = 0;
   break;
  case 49:
   temp1 = 1;
   break;
  case 50:
   temp1 = 2;
   break;
  case 51:
   temp1 = 3;
   break;
  case 52:
   temp1 = 4;
   break;
  case 53:
   temp1 = 5;
   break;
  case 54:
   temp1 = 6;
   break;
  case 55:
   temp1 = 7;
   break;
  case 56:
   temp1 = 8;
   break;
  case 57:
   temp1 = 9;
   break;
  case 65:
   temp1 = 10;
   break;
  case 66:
   temp1 = 11;
   break;
  case 67:
   temp1 = 12;
   break;
  case 68:
   temp1 = 13;
   break;
  case 69:
   temp1 = 14;
   break;
  case 70:
   temp1 = 15;
   break;
 }
 return(temp1);
}
//______________________________________________________________________________________________________________________
// END OF PROGRAM!!
//______________________________________________________________________________________________________________________
